# WARNING: Do not edit by hand, this file was generated by Crank:
#
#   https://github.com/gocardless/crank
#

import json

import pytest
import requests
import responses

from gocardless_pro.errors import MalformedResponseError
from gocardless_pro import resources
from gocardless_pro import list_response

from .. import helpers
  

@responses.activate
def test_bank_account_details_get():
    fixture = helpers.load_fixture('bank_account_details')['get']
    helpers.stub_response(fixture)
    response = helpers.client.bank_account_details.get(*fixture['url_params'])
    body = fixture['body']['bank_account_details']

    assert isinstance(response, resources.BankAccountDetail)
    assert responses.calls[-1].request.headers.get('Idempotency-Key') is None
    assert response.ciphertext == body.get('ciphertext')
    assert response.encrypted_key == body.get('encrypted_key')
    assert response.iv == body.get('iv')
    assert response.protected == body.get('protected')
    assert response.tag == body.get('tag')

@responses.activate
def test_timeout_bank_account_details_get_retries():
    fixture = helpers.load_fixture('bank_account_details')['get']
    with helpers.stub_timeout_then_response(fixture) as rsps:
      response = helpers.client.bank_account_details.get(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['bank_account_details']

    assert isinstance(response, resources.BankAccountDetail)

def test_502_bank_account_details_get_retries():
    fixture = helpers.load_fixture('bank_account_details')['get']
    with helpers.stub_502_then_response(fixture) as rsps:
      response = helpers.client.bank_account_details.get(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['bank_account_details']

    assert isinstance(response, resources.BankAccountDetail)
  
