# WARNING: Do not edit by hand, this file was generated by Crank:
#
#   https://github.com/gocardless/crank
#

import json

import pytest
import requests
import responses

from gocardless_pro.errors import MalformedResponseError
from gocardless_pro import resources
from gocardless_pro import list_response

from .. import helpers
  

@responses.activate
def test_exports_get():
    fixture = helpers.load_fixture('exports')['get']
    helpers.stub_response(fixture)
    response = helpers.client.exports.get(*fixture['url_params'])
    body = fixture['body']['exports']

    assert isinstance(response, resources.Export)
    assert responses.calls[-1].request.headers.get('Idempotency-Key') is None
    assert response.created_at == body.get('created_at')
    assert response.currency == body.get('currency')
    assert response.download_url == body.get('download_url')
    assert response.export_type == body.get('export_type')
    assert response.id == body.get('id')

@responses.activate
def test_timeout_exports_get_retries():
    fixture = helpers.load_fixture('exports')['get']
    with helpers.stub_timeout_then_response(fixture) as rsps:
      response = helpers.client.exports.get(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['exports']

    assert isinstance(response, resources.Export)

def test_502_exports_get_retries():
    fixture = helpers.load_fixture('exports')['get']
    with helpers.stub_502_then_response(fixture) as rsps:
      response = helpers.client.exports.get(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['exports']

    assert isinstance(response, resources.Export)
  

@responses.activate
def test_exports_list():
    fixture = helpers.load_fixture('exports')['list']
    helpers.stub_response(fixture)
    response = helpers.client.exports.list(*fixture['url_params'])
    body = fixture['body']['exports']

    assert isinstance(response, list_response.ListResponse)
    assert isinstance(response.records[0], resources.Export)

    assert response.before == fixture['body']['meta']['cursors']['before']
    assert response.after == fixture['body']['meta']['cursors']['after']
    assert responses.calls[-1].request.headers.get('Idempotency-Key') is None
    assert [r.created_at for r in response.records] == [b.get('created_at') for b in body]
    assert [r.currency for r in response.records] == [b.get('currency') for b in body]
    assert [r.download_url for r in response.records] == [b.get('download_url') for b in body]
    assert [r.export_type for r in response.records] == [b.get('export_type') for b in body]
    assert [r.id for r in response.records] == [b.get('id') for b in body]

@responses.activate
def test_timeout_exports_list_retries():
    fixture = helpers.load_fixture('exports')['list']
    with helpers.stub_timeout_then_response(fixture) as rsps:
      response = helpers.client.exports.list(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['exports']

    assert isinstance(response, list_response.ListResponse)
    assert isinstance(response.records[0], resources.Export)

    assert response.before == fixture['body']['meta']['cursors']['before']
    assert response.after == fixture['body']['meta']['cursors']['after']

def test_502_exports_list_retries():
    fixture = helpers.load_fixture('exports')['list']
    with helpers.stub_502_then_response(fixture) as rsps:
      response = helpers.client.exports.list(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['exports']

    assert isinstance(response, list_response.ListResponse)
    assert isinstance(response.records[0], resources.Export)

    assert response.before == fixture['body']['meta']['cursors']['before']
    assert response.after == fixture['body']['meta']['cursors']['after']

@responses.activate
def test_exports_all():
    fixture = helpers.load_fixture('exports')['list']

    def callback(request):
        if 'after=123' in request.url:
          fixture['body']['meta']['cursors']['after'] = None
        else:
          fixture['body']['meta']['cursors']['after'] = '123'
        return [200, {}, json.dumps(fixture['body'])]

    url = 'http://example.com' + fixture['path_template']
    responses.add_callback(fixture['method'], url, callback)

    all_records = list(helpers.client.exports.all())
    assert len(all_records) == len(fixture['body']['exports']) * 2
    for record in all_records:
      assert isinstance(record, resources.Export)
    
  
