# WARNING: Do not edit by hand, this file was generated by Crank:
#
#   https://github.com/gocardless/crank
#

import json

import pytest
import requests
import responses

from gocardless_pro.errors import MalformedResponseError
from gocardless_pro import resources
from gocardless_pro import list_response

from .. import helpers
  

@responses.activate
def test_mandate_pdfs_create():
    fixture = helpers.load_fixture('mandate_pdfs')['create']
    helpers.stub_response(fixture)
    response = helpers.client.mandate_pdfs.create(*fixture['url_params'])
    body = fixture['body']['mandate_pdfs']

    assert isinstance(response, resources.MandatePdf)
    assert responses.calls[-1].request.headers.get('Idempotency-Key') is not None
    assert response.expires_at == body.get('expires_at')
    assert response.url == body.get('url')

@responses.activate
def test_timeout_mandate_pdfs_create_retries():
    fixture = helpers.load_fixture('mandate_pdfs')['create']
    with helpers.stub_timeout_then_response(fixture) as rsps:
      response = helpers.client.mandate_pdfs.create(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['mandate_pdfs']

    assert isinstance(response, resources.MandatePdf)

def test_502_mandate_pdfs_create_retries():
    fixture = helpers.load_fixture('mandate_pdfs')['create']
    with helpers.stub_502_then_response(fixture) as rsps:
      response = helpers.client.mandate_pdfs.create(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['mandate_pdfs']

    assert isinstance(response, resources.MandatePdf)
  
