# WARNING: Do not edit by hand, this file was generated by Crank:
#
#   https://github.com/gocardless/crank
#

import json

import pytest
import requests
import responses

from gocardless_pro.errors import MalformedResponseError
from gocardless_pro import resources
from gocardless_pro import list_response

from .. import helpers
  

@responses.activate
def test_payouts_list():
    fixture = helpers.load_fixture('payouts')['list']
    helpers.stub_response(fixture)
    response = helpers.client.payouts.list(*fixture['url_params'])
    body = fixture['body']['payouts']

    assert isinstance(response, list_response.ListResponse)
    assert isinstance(response.records[0], resources.Payout)

    assert response.before == fixture['body']['meta']['cursors']['before']
    assert response.after == fixture['body']['meta']['cursors']['after']
    assert responses.calls[-1].request.headers.get('Idempotency-Key') is None
    assert [r.amount for r in response.records] == [b.get('amount') for b in body]
    assert [r.arrival_date for r in response.records] == [b.get('arrival_date') for b in body]
    assert [r.created_at for r in response.records] == [b.get('created_at') for b in body]
    assert [r.currency for r in response.records] == [b.get('currency') for b in body]
    assert [r.deducted_fees for r in response.records] == [b.get('deducted_fees') for b in body]
    assert [r.id for r in response.records] == [b.get('id') for b in body]
    assert [r.metadata for r in response.records] == [b.get('metadata') for b in body]
    assert [r.payout_type for r in response.records] == [b.get('payout_type') for b in body]
    assert [r.reference for r in response.records] == [b.get('reference') for b in body]
    assert [r.status for r in response.records] == [b.get('status') for b in body]
    assert [r.tax_currency for r in response.records] == [b.get('tax_currency') for b in body]

@responses.activate
def test_timeout_payouts_list_retries():
    fixture = helpers.load_fixture('payouts')['list']
    with helpers.stub_timeout_then_response(fixture) as rsps:
      response = helpers.client.payouts.list(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['payouts']

    assert isinstance(response, list_response.ListResponse)
    assert isinstance(response.records[0], resources.Payout)

    assert response.before == fixture['body']['meta']['cursors']['before']
    assert response.after == fixture['body']['meta']['cursors']['after']

def test_502_payouts_list_retries():
    fixture = helpers.load_fixture('payouts')['list']
    with helpers.stub_502_then_response(fixture) as rsps:
      response = helpers.client.payouts.list(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['payouts']

    assert isinstance(response, list_response.ListResponse)
    assert isinstance(response.records[0], resources.Payout)

    assert response.before == fixture['body']['meta']['cursors']['before']
    assert response.after == fixture['body']['meta']['cursors']['after']

@responses.activate
def test_payouts_all():
    fixture = helpers.load_fixture('payouts')['list']

    def callback(request):
        if 'after=123' in request.url:
          fixture['body']['meta']['cursors']['after'] = None
        else:
          fixture['body']['meta']['cursors']['after'] = '123'
        return [200, {}, json.dumps(fixture['body'])]

    url = 'http://example.com' + fixture['path_template']
    responses.add_callback(fixture['method'], url, callback)

    all_records = list(helpers.client.payouts.all())
    assert len(all_records) == len(fixture['body']['payouts']) * 2
    for record in all_records:
      assert isinstance(record, resources.Payout)
    
  

@responses.activate
def test_payouts_get():
    fixture = helpers.load_fixture('payouts')['get']
    helpers.stub_response(fixture)
    response = helpers.client.payouts.get(*fixture['url_params'])
    body = fixture['body']['payouts']

    assert isinstance(response, resources.Payout)
    assert responses.calls[-1].request.headers.get('Idempotency-Key') is None
    assert response.amount == body.get('amount')
    assert response.arrival_date == body.get('arrival_date')
    assert response.created_at == body.get('created_at')
    assert response.currency == body.get('currency')
    assert response.deducted_fees == body.get('deducted_fees')
    assert response.id == body.get('id')
    assert response.metadata == body.get('metadata')
    assert response.payout_type == body.get('payout_type')
    assert response.reference == body.get('reference')
    assert response.status == body.get('status')
    assert response.tax_currency == body.get('tax_currency')
    assert response.fx.estimated_exchange_rate == body.get('fx')['estimated_exchange_rate']
    assert response.fx.exchange_rate == body.get('fx')['exchange_rate']
    assert response.fx.fx_amount == body.get('fx')['fx_amount']
    assert response.fx.fx_currency == body.get('fx')['fx_currency']
    assert response.links.creditor == body.get('links')['creditor']
    assert response.links.creditor_bank_account == body.get('links')['creditor_bank_account']

@responses.activate
def test_timeout_payouts_get_retries():
    fixture = helpers.load_fixture('payouts')['get']
    with helpers.stub_timeout_then_response(fixture) as rsps:
      response = helpers.client.payouts.get(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['payouts']

    assert isinstance(response, resources.Payout)

def test_502_payouts_get_retries():
    fixture = helpers.load_fixture('payouts')['get']
    with helpers.stub_502_then_response(fixture) as rsps:
      response = helpers.client.payouts.get(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['payouts']

    assert isinstance(response, resources.Payout)
  

@responses.activate
def test_payouts_update():
    fixture = helpers.load_fixture('payouts')['update']
    helpers.stub_response(fixture)
    response = helpers.client.payouts.update(*fixture['url_params'])
    body = fixture['body']['payouts']

    assert isinstance(response, resources.Payout)
    assert responses.calls[-1].request.headers.get('Idempotency-Key') is None
    assert response.amount == body.get('amount')
    assert response.arrival_date == body.get('arrival_date')
    assert response.created_at == body.get('created_at')
    assert response.currency == body.get('currency')
    assert response.deducted_fees == body.get('deducted_fees')
    assert response.id == body.get('id')
    assert response.metadata == body.get('metadata')
    assert response.payout_type == body.get('payout_type')
    assert response.reference == body.get('reference')
    assert response.status == body.get('status')
    assert response.tax_currency == body.get('tax_currency')
    assert response.fx.estimated_exchange_rate == body.get('fx')['estimated_exchange_rate']
    assert response.fx.exchange_rate == body.get('fx')['exchange_rate']
    assert response.fx.fx_amount == body.get('fx')['fx_amount']
    assert response.fx.fx_currency == body.get('fx')['fx_currency']
    assert response.links.creditor == body.get('links')['creditor']
    assert response.links.creditor_bank_account == body.get('links')['creditor_bank_account']

@responses.activate
def test_timeout_payouts_update_retries():
    fixture = helpers.load_fixture('payouts')['update']
    with helpers.stub_timeout_then_response(fixture) as rsps:
      response = helpers.client.payouts.update(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['payouts']

    assert isinstance(response, resources.Payout)

def test_502_payouts_update_retries():
    fixture = helpers.load_fixture('payouts')['update']
    with helpers.stub_502_then_response(fixture) as rsps:
      response = helpers.client.payouts.update(*fixture['url_params'])
      assert len(rsps.calls) == 2
      assert rsps.calls[0].request.headers.get('Idempotency-Key') == rsps.calls[1].request.headers.get('Idempotency-Key')
    body = fixture['body']['payouts']

    assert isinstance(response, resources.Payout)
  
