# WARNING: Do not edit by hand, this file was generated by Crank:
#
#   https://github.com/gocardless/crank
#

import json

import pytest
import requests
import responses

from gocardless_pro.errors import MalformedResponseError
from gocardless_pro import resources
from gocardless_pro import list_response

from .. import helpers
  

@responses.activate
def test_scenario_simulators_run():
    fixture = helpers.load_fixture('scenario_simulators')['run']
    helpers.stub_response(fixture)
    response = helpers.client.scenario_simulators.run(*fixture['url_params'])
    body = fixture['body']['scenario_simulators']

    assert isinstance(response, resources.ScenarioSimulator)
    assert responses.calls[-1].request.headers.get('Idempotency-Key') is not None
    assert response.id == body.get('id')

def test_timeout_scenario_simulators_run_doesnt_retry():
    fixture = helpers.load_fixture('scenario_simulators')['run']
    with helpers.stub_timeout(fixture) as rsps:
      with pytest.raises(requests.ConnectTimeout):
        response = helpers.client.scenario_simulators.run(*fixture['url_params'])
      assert len(rsps.calls) == 1

def test_502_scenario_simulators_run_doesnt_retry():
    fixture = helpers.load_fixture('scenario_simulators')['run']
    with helpers.stub_502(fixture) as rsps:
      with pytest.raises(MalformedResponseError):
        response = helpers.client.scenario_simulators.run(*fixture['url_params'])
      assert len(rsps.calls) == 1
  
